## libmirage-3.3.1.tar.xz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(libmirage VERSION 3.3.1 LANGUAGES C)

# Semantic versioning 2.0.0 (semver.org):
# MAJOR is increased when backwards-incompatible changes are made to
# the API (e.g., removal of interfaces). In this case, MINOR and PATCH
# should be reset to zero.
# MINOR is increased when features are added to the API (e.g., addition
# of interfaces). In this case, PATCH should be reset to zero.
# PATCH is increased for all other changes such as bug-fixes.
set(MIRAGE_SOVERSION_MAJOR 12)
set(MIRAGE_SOVERSION_MINOR 0)
set(MIRAGE_SOVERSION_PATCH 0)

# The version if GIR (GObject Introspection) namespace. Similar to the
# soversion, but with separate update criteria. For historic reasons,
# the current version of the namespace is 3.2.
set(MIRAGE_GIR_VERSION "3.2")

# Additional CMake modules
list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

# CMake modules
include(GNUInstallDirs)

# Options
option(GTKDOC_ENABLED "Use gtk-doc to build documentation" ON)
option(INTROSPECTION_ENABLED "Generate gobject introspection files" ON)
option(VAPI_ENABLED "Generate the Vala API file" ON)
option(POST_INSTALL_HOOKS "Run post-install hooks" ON)
option(PEDANTIC_MODE "Enable -pedantic flag on gcc compiler" OFF)

# Plugin directory
set(MIRAGE_PLUGIN_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/libmirage-${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}" CACHE PATH "Path to libMirage plugin directory." FORCE)

# Dependencies
find_package(PkgConfig 0.16 REQUIRED)
find_package(IntlTool 0.21 REQUIRED)
find_package(Gettext 0.15 REQUIRED)

pkg_check_modules(GLIB REQUIRED glib-2.0>=2.38 gobject-2.0>=2.38 gmodule-2.0>=2.38 gio-2.0>=2.38 IMPORTED_TARGET)

if(INTROSPECTION_ENABLED)
    pkg_check_modules(INTROSPECTION gobject-introspection-1.0>=1.42.0)
    if(INTROSPECTION_FOUND)
        include(GObjectIntrospection)
        set(INTROSPECTION_STATUS "ON")
    else()
        set(INTROSPECTION_STATUS "OFF (not found)")
    endif()
else()
    set(INTROSPECTION_STATUS "OFF (disabled)")
endif()

if(VAPI_ENABLED)
    if(NOT (INTROSPECTION_ENABLED AND INTROSPECTION_FOUND))
        set(VAPI_STATUS "OFF (introspection disabled)")
    else()
        find_program(VALAC valac DOC "the Vala compiler")
        find_program(VAPIGEN vapigen DOC "tool to generate the Vala API")
        if(VALAC AND VAPIGEN)
            include(GObjectIntrospection)
            set(VAPI_STATUS "ON")
        else()
            set(VAPI_STATUS "OFF (not found)")
        endif()
    endif()
else()
    set(VAPI_STATUS "OFF (disabled)")
endif()

if(GTKDOC_ENABLED)
    pkg_check_modules(GTKDOC gtk-doc>=1.4)
    if(GTKDOC_FOUND)
        include(GtkDoc)
        set(GTKDOC_STATUS "ON")
    else()
        set(GTKDOC_STATUS "OFF (not found)")
    endif()
else()
    set(GTKDOC_STATUS "OFF (disabled)")
endif()

if(POST_INSTALL_HOOKS)
    find_program(UPDATE_MIME_DATABASE_EXECUTABLE NAMES update-mime-database)
    mark_as_advanced(UPDATE_MIME_DATABASE_EXECUTABLE)
endif()


# Auto-generated files
configure_file(${PROJECT_SOURCE_DIR}/mirage/config.h.in ${PROJECT_BINARY_DIR}/mirage/config.h)
configure_file(${PROJECT_SOURCE_DIR}/mirage/version.h.in ${PROJECT_BINARY_DIR}/mirage/version.h)
configure_file(${PROJECT_SOURCE_DIR}/reference/version.xml.in ${PROJECT_BINARY_DIR}/reference/version.xml)
configure_file(${PROJECT_SOURCE_DIR}/libmirage.pc.in ${PROJECT_BINARY_DIR}/libmirage.pc @ONLY)

# Global definitions
set(CMAKE_C_STANDARD 99) # Enable C99
if(CMAKE_COMPILER_IS_GNUCC)
    # Enable additional warnings
    add_definitions(-Wall -Wextra -Wshadow -Wmissing-declarations -Wmissing-prototypes -Wnested-externs -Wpointer-arith -Wcast-align)
    if(PEDANTIC_MODE)
        add_definitions(-pedantic)
    endif()
endif()

# *** libMirage core library ***
set(libmirage_HEADERS
    mirage/mirage.h
    mirage/cdtext-coder.h
#    mirage/compat-input-stream.h
    mirage/context.h
    mirage/contextual.h
    mirage/debug.h
    mirage/disc.h
    mirage/error.h
    mirage/file-stream.h
    mirage/filter-stream.h
    mirage/fragment.h
    mirage/index.h
    mirage/language.h
    mirage/object.h
    mirage/parser.h
    mirage/plugin.h
    mirage/sector.h
    mirage/session.h
    mirage/stream.h
    mirage/track.h
    mirage/types.h
    mirage/utils.h
#    mirage/utils-private.h
    mirage/writer.h
    ${PROJECT_BINARY_DIR}/mirage/version.h
#    ${PROJECT_BINARY_DIR}/mirage/config.h
)

set(libmirage_SOURCES
    mirage/mirage.c
    mirage/cdtext-coder.c
    mirage/compat-input-stream.c
    mirage/context.c
    mirage/contextual.c
    mirage/disc.c
    mirage/error.c
    mirage/file-stream.c
    mirage/filter-stream.c
    mirage/fragment.c
    mirage/index.c
    mirage/language.c
    mirage/object.c
    mirage/parser.c
    mirage/plugin.c
    mirage/sector.c
    mirage/session.c
    mirage/stream.c
    mirage/track.c
    mirage/utils.c
    mirage/utils-private.c
    mirage/version.c
    mirage/writer.c
)

add_library(mirage SHARED ${libmirage_SOURCES})

target_include_directories(mirage PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<INSTALL_INTERFACE:include/libmirage-${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}>)

target_link_libraries(mirage PUBLIC PkgConfig::GLIB)

set_target_properties(mirage PROPERTIES
    LIBRARY_OUTPUT_NAME mirage
    VERSION ${MIRAGE_SOVERSION_MAJOR}.${MIRAGE_SOVERSION_MINOR}.${MIRAGE_SOVERSION_PATCH}
    SOVERSION ${MIRAGE_SOVERSION_MAJOR}
)

install(TARGETS mirage DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${libmirage_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libmirage-${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}/mirage)

# Translations; we use the version provided by our FindIntlTool.cmake
# instead of the gettext version... Note: first two arguments are mandatory,
# the rest is an optional list of languages to process. If no languages
# are given, all POs are processed.
intltool_process_po_files(${PROJECT_SOURCE_DIR}/po ${PROJECT_NAME})

# *** Introspection ***
if(INTROSPECTION_ENABLED AND INTROSPECTION_FOUND)
    gobject_introspection(
        FILENAME Mirage-${MIRAGE_GIR_VERSION}.gir
        NSVERSION ${MIRAGE_GIR_VERSION}
        INCLUDES GObject-2.0 Gio-2.0 GLib-2.0 GModule-2.0
        LIBRARY mirage
        QUIET
        SCANNER_ARGS --c-include=mirage/mirage.h --warn-all
        COMPILER_ARGS --includedir=${PROJECT_SOURCE_DIR} --includedir=${PROJECT_BINARY_DIR}
        CFLAGS -I${PROJECT_SOURCE_DIR} -I${PROJECT_BINARY_DIR}
        SYMBOL_PREFIXES mirage
        IDENTIFIER_PREFIXES Mirage
        SOURCES ${libmirage_SOURCES} ${libmirage_HEADERS}
    )
endif()

# *** Vala API ***
if(INTROSPECTION_ENABLED AND INTROSPECTION_FOUND AND VALAC AND VAPIGEN)
    add_custom_target(vala ALL)
    set(gir_fullname ${CMAKE_BINARY_DIR}/Mirage-${MIRAGE_GIR_VERSION}.gir)
    set(vapi_file ${CMAKE_CURRENT_BINARY_DIR}/libmirage.vapi)

    add_custom_command(OUTPUT ${vapi_file}
        COMMAND ${VAPIGEN}
            --vapidir=${CMAKE_CURRENT_SOURCE_DIR}
            --vapidir=${CMAKE_CURRENT_BINARY_DIR}
            --girdir=${CMAKE_BINARY_DIR}/src/libmirage
            --pkg gio-2.0
            --library libmirage
            --metadatadir=${CMAKE_CURRENT_SOURCE_DIR}
            --metadatadir=${CMAKE_CURRENT_BINARY_DIR}
            ${gir_fullname}
        DEPENDS
            ${gir_fullname}
    )

    add_custom_target(valafile DEPENDS ${vapi_file})

    add_dependencies(vala valafile)

    install(FILES ${vapi_file} DESTINATION ${CMAKE_INSTALL_DATADIR}/vala/vapi)
endif ()

# *** Documentation ***
if(GTKDOC_ENABLED AND GTKDOC_FOUND)
    get_target_property(GTKDOC_LIB mirage LIBRARY_OUTPUT_NAME)
    gtk_doc(
        MODULE ${PROJECT_NAME}
        MAIN_SGML_FILE ${PROJECT_NAME}-docs.sgml
        SOURCE_DIR ${PROJECT_SOURCE_DIR}/mirage ${PROJECT_BINARY_DIR}/mirage
        SOURCES ${libmirage_HEADERS} ${libmirage_SOURCES}
        DOCS_DIR ${PROJECT_SOURCE_DIR}/reference
        IGNORE_HFILES compat-input-stream.h config.h utils-private.h
        CFLAGS ${GLIB_CFLAGS}
        LDFLAGS ${GLIB_LDFLAGS} -L${PROJECT_BINARY_DIR}
            -Wl,-rpath,${PROJECT_BINARY_DIR} -l${GTKDOC_LIB}
    )
endif()

# *** Pkg-config ***
install(FILES ${PROJECT_BINARY_DIR}/libmirage.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

# *** Filters ***
file(GLOB filters RELATIVE ${PROJECT_SOURCE_DIR}/filters/ ${PROJECT_SOURCE_DIR}/filters/*)
foreach(filter ${filters})
    string(REGEX REPLACE "^filter-" "" filter_name ${filter})
    list(FIND FILTERS_DISABLED ${filter_name} filter_disabled)
    if(filter_disabled EQUAL -1)
        add_subdirectory(filters/filter-${filter_name})
    endif()
endforeach()
if(FILTERS_ENABLED)
    list(SORT FILTERS_ENABLED)
endif()
if(FILTERS_DISABLED)
    list(SORT FILTERS_DISABLED)
endif()

# *** Images ***
file(GLOB images RELATIVE ${PROJECT_SOURCE_DIR}/images/ ${PROJECT_SOURCE_DIR}/images/*)
foreach(image ${images})
    string(REGEX REPLACE "^image-" "" image_name ${image})
    list(FIND IMAGE_FORMATS_DISABLED ${image_name} image_disabled)
    if(image_disabled EQUAL -1)
        add_subdirectory(images/image-${image_name})
    endif()
endforeach()
if(IMAGE_FORMATS_ENABLED)
    list(SORT IMAGE_FORMATS_ENABLED)
endif()
if(IMAGE_FORMATS_DISABLED)
    list(SORT IMAGE_FORMATS_DISABLED)
endif()

# *** Configuration summary ***
message(STATUS "")
message(STATUS "*** libMirage v${PROJECT_VERSION} configuration summary ***")
message(STATUS "Installation:")
message(STATUS " install prefix: " ${CMAKE_INSTALL_PREFIX})
message(STATUS " plugin dir: " ${MIRAGE_PLUGIN_DIR})
message(STATUS "File filters:")
message(STATUS " enabled: ${FILTERS_ENABLED}")
message(STATUS " disabled: ${FILTERS_DISABLED}")
message(STATUS "Image formats:")
message(STATUS " enabled: ${IMAGE_FORMATS_ENABLED}")
message(STATUS " disabled: ${IMAGE_FORMATS_DISABLED}")
message(STATUS "Options:")
message(STATUS " pedantic mode: " ${PEDANTIC_MODE})
message(STATUS " build gtk-doc documentation: " ${GTKDOC_STATUS})
message(STATUS " build gobject-introspection bindings: " ${INTROSPECTION_STATUS})
message(STATUS " build Vala bindings: " ${VAPI_STATUS})
message(STATUS " run post-install hooks: " ${POST_INSTALL_HOOKS})
message(STATUS "")

=== debian/changelog ===
libmirage (3.3.1-1) unstable; urgency=medium

  * New upstream version.

 -- Matteo Bini <matteobin@tiepi.it>  Sun, 15 Feb 2026 19:15:00 +0100

libmirage (3.3.0-1) unstable; urgency=medium

  * New upstream version.

 -- Matteo Bini <matteobin@tiepi.it>  Mon, 09 Feb 2026 17:00:00 +0100

libmirage (3.2.10-1) unstable; urgency=medium

  * New upstream version.
  * debian/appstream/net.sf.cdemu.libmirage.metainfo.xml:
    - Add 3.2.8, 3.2.9 and 3.2.10 releases.
  * debian/control:
    - Bump Standards-Version to 4.7.2.

 -- Matteo Bini <matteobin@tiepi.it>  Wed, 23 Apr 2025 13:58:00 +0200

libmirage (3.2.9-1) unstable; urgency=medium

  * New upstream version.

 -- Matteo Bini <matteobin@tiepi.it>  Fri, 11 Oct 2024 09:09:37 +0200

libmirage (3.2.8-1) unstable; urgency=medium

  * New upstream version.
  * debian/control:
    - Add Provides: gir1.2-mirage-3.2-dev (= ${binary:Version}), to fix
      Lintian gir-package-name-does-not-match warning.

 -- Matteo Bini <matteobin@tiepi.it>  Sat, 03 Aug 2024 08:16:11 +0200

libmirage (3.2.7-5) unstable; urgency=medium

  * debian/rules:
    - Disable gtk-doc on arch-only build (closes: #1072160). Thanks to
      Helmut Grohne <helmut@subdivi.de> for the patch.

 -- Matteo Bini <matteobin@tiepi.it>  Sun, 23 Jun 2024 11:49:22 +0200

libmirage (3.2.7-4) unstable; urgency=medium

  * debian/appstream/net.sf.cdemu.libmirage.metainfo.xml:
    - Add developer.
  * debian/control:
    - Bump Standards-Version to 4.7.0.
  * debian/source/lintian-overrides:
    - Add missing-build-dependency-for-dh-addon.

 -- Matteo Bini <matteobin@tiepi.it>  Sat, 25 May 2024 12:55:24 +0200

libmirage (3.2.7-3) unstable; urgency=low

  * debian/control:
    - Add Multi-Arch: same to gir1.2-mirage-3.2.

 -- Matteo Bini <matteobin@tiepi.it>  Thu, 21 Mar 2024 13:23:51 +0100

libmirage (3.2.7-2) unstable; urgency=low

  * debian/control:
    - Add Multi-Arch: foreign to libmirage-doc and Multi-Arch: same to
      libmirage11.

 -- Matteo Bini <matteobin@tiepi.it>  Sun, 10 Mar 2024 14:51:34 +0100

libmirage (3.2.7-1) unstable; urgency=low

  * Initial release, closes: #983444.

 -- Matteo Bini <matteobin@tiepi.it>  Tue, 20 Feb 2024 16:56:31 +0100

=== debian/control ===
Source: libmirage
Section: libs
Priority: optional
Homepage: https://cdemu.sourceforge.io/
Maintainer: Matteo Bini <matteobin@tiepi.it>
Build-Depends: cmake (>= 3.16.0),
               debhelper-compat (= 13),
               gtk-doc-tools,
               intltool,
               libbz2-dev,
               liblzma-dev,
               libglib2.0-dev (>= 2.38),
               libsamplerate0-dev,
               libsndfile1-dev,
               pkgconf,
               zlib1g-dev,
               libgcrypt20-dev,
               gobject-introspection (>= 1.80),
               gir1.2-gobject-2.0-dev,
               gir1.2-gio-2.0-dev,
               gir1.2-gmodule-2.0-dev
Standards-Version: 4.7.2
Rules-Requires-Root: no


Package: libmirage12
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Conflicts: libmirage9, libmirage10, libmirage11
Replaces: libmirage9, libmirage10, libmirage11
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: CD-ROM image access library
 This is libMirage library, a CD-ROM image access library, and part of the
 CDEmu suite, a free, GPL CD/DVD-ROM device emulator for Linux. It is
 written in C and based on GLib.
 .
 The aim of libMirage is to provide uniform access to the data stored in
 different image formats, by creating a representation of disc stored in image
 file, which is based on GObjects.


Package: gir1.2-mirage-3.2
Section: introspection
Architecture: any
Multi-Arch: same
Conflicts: gir1.2-mirage-3.1
Replaces: gir1.2-mirage-3.1
Depends: libmirage12 (= ${binary:Version}), ${gir:Depends}, ${misc:Depends}
Description: CD-ROM image access library (typelib files)
 libMirage is a CD-ROM image access library, part of the CDEmu suite,
 a free, GPL CD/DVD-ROM device emulator for Linux.
 .
 This package provides typelib files.


Package: libmirage-dev
Section: libdevel
Architecture: any
Provides: ${gir:Provides}
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${gir:Depends},
         gir1.2-mirage-3.2 (= ${binary:Version}),
         libmirage12 (= ${binary:Version})
Description: CD-ROM image access library development files
 libMirage is a CD-ROM image access library, part of the CDEmu suite,
 a free, GPL CD/DVD-ROM device emulator for Linux.
 .
 This package contains the files needed to compile and link programs which
 use libMirage.


Package: libmirage-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: devhelp
Multi-Arch: foreign
Description: Reference manual for libMirage
 libMirage is a CD-ROM image access library, part of the CDEmu suite,
 a free, GPL CD/DVD-ROM device emulator for Linux.
 .
 This package contains the reference manual.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

#export DH_VERBOSE=1


override_dh_auto_configure:
	dh_auto_configure -- \
		-DPOST_INSTALL_HOOKS:BOOL=OFF \
		-DGTKDOC_ENABLED=$(if $(filter libmirage-doc,$(shell dh_listpackages)),ON,OFF)

override_dh_makeshlibs:
	dh_makeshlibs --exclude="libmirage-3.3"

override_dh_shlibdeps:
	dh_shlibdeps --exclude="libmirage-3.3"

%:
	dh $@ --with gir
